﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Controls.Charts;

namespace XamDataChartMarker
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        AxisAnnotation xAnnotation;
        AxisAnnotation yAnnotation;
        public MainWindow()
        {
            InitializeComponent();

            LiveViewDataPoint Trades = new LiveViewDataPoint();

            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now, Price = 0 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(1), Price = 120 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(2), Price = 45.56 });
            Trades.Add(new LiveViewDataPoint() { Date = DateTime.Now.AddDays(3), Price = 80.25 });

            this.DataContext = Trades;


        }
        private void xamChart1_Loaded(object sender, RoutedEventArgs e)
        {

            yAnnotation = new AxisAnnotation()
            {
                Value = 0,
                BackgroundCornerRadius = 0.0,
                Text = "0",
                BackgroundPadding = new Thickness(2),
                Background = Brushes.Gray
            };

            xAnnotation = new AxisAnnotation()
            {
                Value = DateTime.Now,
                Text = DateTime.Now.ToShortDateString(),
                BackgroundPadding = new Thickness(2),
                Background = Brushes.Gray,
                BackgroundCornerRadius = 0.0
            };

            YAxis1.Annotations.Add(yAnnotation);
            XAxis1.Annotations.Add(xAnnotation);
        }

        private void xamChart1_ActualWindowRectChanged(object sender, Infragistics.RectChangedEventArgs e)
        {
            //Dispatcher.BeginInvoke(new Action(() =>
            //{

            Rect rect = this.chart.ContentViewport;

            long xMin = (long)XAxis1.UnscaleValue(rect.Left + 1);
            double yMin = YAxis1.UnscaleValue(rect.Top + rect.Height - 1);

            yAnnotation.Value = yMin;
            yAnnotation.Text = yMin.ToString();

            DateTime date = new DateTime(xMin);

            xAnnotation.Value = date;
            xAnnotation.Text = date.ToShortDateString();

            System.Diagnostics.Debug.WriteLine(yMin);

            var x = chart.ExportVisualData().Axes[0].Labels;

            //}));
            //for (var i = 0; i < this.chart.Axes.Count; i++)
            //{
            //    var axis = this.chart.Axes[i] as IgcNumericAxisBaseComponent;

            //    var min = 0;
            //    var max = 0;

            //    if (axis.isVertical)
            //    {
            //        min = axis.unscaleValue((this.chart.contentViewport.top + this.chart.contentViewport.height - 1);
            //        max = axis.unscaleValue(this.chart.contentViewport.top + 1);
            //    }
            //    else
            //    {
            //        min = axis.unscaleValue(this.chart.contentViewport.left + 1);
            //        max = axis.unscaleValue(this.chart.contentViewport.left + this.chart.contentViewport.width - 1);
            //    }

            //    axis.annotations.clear();

            //    var minAnnotation = new IgcAxisAnnotation();
            //    minAnnotation.text = min.toFixed(2);
            //    minAnnotation.value = min;
            //    minAnnotation.backgroundPaddingBottom = 0;
            //    minAnnotation.backgroundPaddingLeft = 2;
            //    minAnnotation.backgroundPaddingTop = 0;
            //    minAnnotation.backgroundPaddingRight = 2;
            //    minAnnotation.background = "rgba(240,240,240,1)";
            //    minAnnotation.outline = "transparent";
            //    axis.annotations.add(minAnnotation);

            //    var maxAnnotation = new IgcAxisAnnotation();
            //    maxAnnotation.text = max.toFixed(2);
            //    maxAnnotation.value = max;
            //    maxAnnotation.backgroundPaddingBottom = 0;
            //    maxAnnotation.backgroundPaddingLeft = 2;
            //    maxAnnotation.backgroundPaddingTop = 0;
            //    maxAnnotation.backgroundPaddingRight = 2;
            //    maxAnnotation.background = "rgba(240,240,240,1)";
            //    maxAnnotation.outline = "transparent";
            //    axis.annotations.add(maxAnnotation);
            //}
        }
    }

    public class LiveViewDataPoint : ObservableCollection<LiveViewDataPoint>, INotifyPropertyChanged
    {
        public DateTime Date { get; set; }
        public double Price { get; set; }
        private bool pointLabelsIsVisible { get; set; }

        public LiveViewDataPoint()
        {
            PointLabelsIsVisible = true;
        }

        public bool PointLabelsIsVisible
        {
            get { return this.pointLabelsIsVisible; }

            set
            {
                if (value != this.pointLabelsIsVisible)
                {
                    this.pointLabelsIsVisible = value;
                    NotifyPropertyChanged("PointLabelsIsVisible");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

    }
}